(*        GREATIS DELPHI PAGES         *)
(* Copyright (C) 2001 Greatis Software *)
(*  web: http://www.greatisdelphi.com  *)
(*     e-mail: delphi@greatis.com      *)

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Year, Month, Day: Word;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  YourDate, JunFirst: TDateTime;
  Week, More, Days: Integer;
  DaysLeft: Real;
begin
  YourDate:=StrToDate(Edit1.Text);
  DecodeDate(YourDate, Year, Month, Day);
  JunFirst:=EncodeDate(Year, 1, 1);
  case DayOfWeek(YourDate) of
    1   : More:=0;
    2..7: More:=1;
  end;
  Days:=Trunc(YourDate-JunFirst)+1;
  Week:=(Days div 7)+More;
  DaysLeft:=Days mod 7;
  case DayOfWeek(JunFirst) of
    1   : More:=1;
    2..7: More:=9-DayOfWeek(JunFirst);
  end;
  if (DaysLeft-More>=0) then Week:=Week+1;
  Label2.Caption:='Week number '+IntToStr(Week);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text:=DateToStr(Now);
end;

end.
